/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
#ifndef _JS_ZONE_H_
#define _JS_ZONE_H_

#include <assert.h>
#include "js-runtimenew.h"
#include "js-gc.h"

/* Classes */
class JSRuntime;
class JSZone: public JSRuntimeNew, public JSGCMemory {
    protected:
	class Allocator: public JSGCMemory::MemoryAllocator {
	    protected:
		JSRuntime *runtime;

	    public:
		Allocator(JSRuntime *runtime);

		void	*memalign(JSContext* cx, size_t alignment, size_t size);
		void	*malloc(JSContext* cx, size_t size);
		void	free(void *ptr);
	} ;

	class PhaseListener: public JSGCMemory::PhaseListener {
	    public:
		void markAll(JSContext* cx);
		void finalize(JSContext* cx, void *obj);
		void stopWorld();
		void resumeWorld();
	} ;
#ifdef THREADS
	class MutexListener: public JSGCMemory::MutexListener {
	    public:
		void    lock();
		void    unlock();
	} ;
#endif

    protected:
	Allocator	allocator;
	PhaseListener	phaseListener;
#ifdef THREADS
	MutexListener	mutexListener;
#endif

    public:
	JSZone(JSRuntime *runtime);
	void  operator delete(void *ptr) {
	    assert(0);
	}

	void	destroy(JSRuntime *runtime);
} ;

#endif /* _JS_ZONE_H_ */

